var Data =
{
    categories: [],
    category: [],
    categorieRACount: 0,
    categorieRealRACount: 0,
    categorieODCount: 0,

    contentCount: 0,
    contentTitle1: "",
    contentTitle2: "",
    contentViewGroup: "",
    contentIdentifier: "",
    contentUserAgent: "",
    contentContent: "",
    contentHttpCookies: "",
    contentHttpHeaders: "",

    contentAccessTokens: [],
    contentArts: [],
    contentAspectRatios: [],
    contentAudios: [],
    contentBanner: [],
    contentBitrates: [],
    contentCasts: [],
    contentContainerType: [],
    contentContentRatings: [],
    contentCollections: [],
    contentDeleteds: [],
    contentDirectors: [],
    contentDurations: [],
    contentFiles: [],
    contentGenres: [],
    contentGrandParentTitles: [],
    contentGrandParentThumbs: [],
    contentHeights: [],
    contentIds: [],
    contentIndexs: [],
    contentKeys: [],
    contentLeafCounts: [],
    contentMachineIndentifiers: [],
    contentMedias: [],
    contentMetadataUrls: [],
    contentTitles: [],
    contentOffsets: [],
    contentOriginallyAvailableAt: [],
    contentParentIndexs: [],
    contentParentKey: [],
    contentPrompts: [],
    contentParentRatingKey: [],
    contentParentTitles: [],
    contentRatingKeys: [],
    contentRatings: [],
    contentSearch: [],
    contentServerAddresses: [],
    contentServerHosts: [],
    contentServerNames: [],
    contentServerOwned: [],
    contentServerLocal: [],
    contentServerPorts: [],
    contentServerVersions: [],
    contentSettings: [],
    contentSourceTitles: [],
    contentStudios: [],
    contentSummarys: [],
    contentTaglines: [],
    contentTextureAudioChannels: [],
    contentTextureAudioCodecs: [],
    contentTextureVideoARs: [],
    contentTextureVideoCodecs: [],
    contentTextureVideoFramerates: [],
    contentTextureVideoResolutions: [],
    contentThemes: [],
    contentThumbs: [],
    contentTypes: [],
    contentUnViewedLeafCounts: [],
    contentViewCounts: [],
    contentViewedLeafCounts: [],
    contentWidths: [],
    contentWriters: [],
    contentYears: []
};

Data.clearContent = function () {
    Data.contentAccessTokens = [];
    Data.contentArts = [];
    Data.contentAspectRatios = [];
    Data.contentAudios = [];
    Data.contentBanner = [];
    Data.contentBitrates = [];
    Data.contentCasts = [];
    Data.contentContainerType = [];
    Data.contentContentRatings = [];
    Data.contentCollections = [];
    Data.contentDeleteds = [];
    Data.contentDirectors = [];
    Data.contentDurations = [];
    Data.contentFiles = [];
    Data.contentGenres = [];
    Data.contentHeights = [];
    Data.contentIds = [];
    Data.contentIndexs = [];
    Data.contentKeys = [];
    Data.contentLeafCounts = [];
    Data.contentMachineIndentifiers = [];
    Data.contentMedias = [];
    Data.contentMetadataUrls = [];
    Data.contentTitles = [];
    Data.contentOffsets = [];
    Data.contentOriginallyAvailableAt = [];
    Data.contentParentIndexs = [];
    Data.contentParentKey = [];
    Data.contentPrompts = [];
    Data.contentParentRatingKey = [];
    Data.contentParentTitles = [];
    Data.contentRatingKeys = [];
    Data.contentRatings = [];
    Data.contentSearch = [];
    Data.contentServerAddresses = [];
    Data.contentServerNames = [];
    Data.contentServerOwned = [];
    Data.contentServerLocal = [];
    Data.contentServerPorts = [];
    Data.contentServerVersions = [];
    Data.contentSettings = [];
    Data.contentSourceTitles = [];
    Data.contentStudios = [];
    Data.contentSummarys = [];
    Data.contentTaglines = [];
    Data.contentTextureAudioChannels = [];
    Data.contentTextureAudioCodecs = [];
    Data.contentTextureVideoARs = [];
    Data.contentTextureVideoCodecs = [];
    Data.contentTextureVideoFramerates = [];
    Data.contentTextureVideoResolutions = [];
    Data.contentThemes = [];
    Data.contentThumbs = [];
    Data.contentTypes = [];
    Data.contentUnViewedLeafCounts = [];
    Data.contentViewCounts = [];
    Data.contentViewedLeafCounts = [];
    Data.contentWidths = [];
    Data.contentWriters = [];
    Data.contentYears = [];
};


/*####################################
####      CATEGORIE
####################################*/

Data.categorieKey = function (index) {
    var url = Data.categorieKeys[index];

    if (url)    // Check for undefined entry (outside of valid array)
    {
        return url;
    }
    else {
        return null;
    }
};

Data.getCategorieCount = function () {
    return Data.category.length;
};


/*####################################*/
/*####      CATEGORIE SECTION */
/*####################################*/

Data.getSectionCount = function () {
    return Data.contentTitles.length;
};

/*####################################*/
/*####      MOVIE */
/*####################################*/

Data.getMovieURL = function (index) {
    var url = Data.contentKeys[index];

    if (url)    // Check for undefined entry (outside of valid array)
    {
        return url;
    }
    else {
        return null;
    }
};

/*####################################
####      SEASON 
####################################*/

Data.getRealSeasonCount = function () {
    var x = 0;
    for (var i = 0; i < Data.contentCount; i++) {
        if (Data.contentTitles[i] !== "All episodes")
            x++;
    }
    return x;
};

/*####################################
####      EPISODE 
####################################*/

Data.getEpisodeIDs = function (index) {
    return Data.contentRatingKeys[index];
};

Data.getEpisodeOffsets = function (index) {
    var offset = Data.contentOffsets[index];
    if (isNaN(offset)) {
        return 0;
    }
    else {
        return offset;
    }
};

Data.getEpisodeAudios = function (index) {
    return Data.contentAudios[index];
};

Data.getEpisodeURL = function (index) {
    var url = Data.contentKeys[index];

    if (url)    // Check for undefined entry (outside of valid array)
    {
        return url;
    }
    else {
        return null;
    }
};

Data.getEpisodeCount = function () {
    return Data.contentTitles.length;
};

/*####################################
####      CHANNELS 
####################################*/

Data.getChannelCount = function () {
    return Data.channelNames.length;
};
Data.getChannelIDs = function (index) {
    return Data.channelIDs[index];
};

/*####################################
####      MULTIPLE USE 
####################################*/

Data.getMetadataURL = function () {
    var url = "";

    if (Main.mediaContent === Main.EPISODE) {
        url = Data.contentMetadataUrls[Main.selectedEpisode];
    }
    else {
        url = Data.contentMetadataUrls[Main.selectedContent];
    }

    return url;
};

Data.getRatingKey = function () {
    var key = "";

    if (Main.mediaContent === Main.EPISODE) {
        key = Data.contentRatingKeys[Main.selectedEpisode];
    }
    else {
        key = Data.contentRatingKeys[Main.selectedContent];
    }

    return key;
};

Data.hasCategorieType = function (categorieType) {
    for (var i = 0; i < Data.category.length; i++) {
        if (Data.category[i].type === categorieType) {
            return true;
        }
    }
    return false;
};

