var buttonSetting = {
    set: 0, // what did I select in the sub setting(buttonSetting.ADD, buttonSetting.EDIT,....)
    lock: 99, // 99 means I am in no sub setting
    str: "",
    selectedSetting: 0,
    selectedSettingTop: 212,

    pmsList: [],
    selectedPMS: 0,
    selectedPMSTop: 131,
    deletedPMS: "",
    countPMS: 0,

    selectedSubSettingTop: 131, // sub means not subtitles, means like subsection
    selectedSubSetting: 0, // sub means not subtitles, means like subsection

    selectedColor: 0,
    colorArray: ["subColorWhite", "subColorBlack", "subColorRed", "subColorGreen", "subColorYellow", "subColorOrange", "subColorGrey"],

    languageArray: ["en", "nl", "de"],

    pollTimer: 0,
    pollCounter: 0,

    RIGHT: 0,
    LEFT: 1,
    DOWN: 2,
    UP: 3,

    GS: 0,
    PLA: 1,
    PMS: 2,
    SUBS: 3,
    SYSTEM: 4,
    ADVANCED: 5,
    ABOUT: 6,

    Styles: 2,
    Trans: 3,

    // GS
    TIME: 0,
    CLOCK: 1,
    DB: 2,
    FX: 3,
    TIMEOUT: 4,
    SCREENSAVER: 5,
    LANG: 6,

    //PLA
    THEME: 0,
    FF: 1,
    RW: 2,
    IB: 3,
    PB: 4,
    TB: 5,
    TC: 6,
    QT: 7,
    //PMS
    ADD: 1,
    EDIT: 2,
    DELETE: 3,
    // SUBS    
    AUDIO: 0,
    BOOST: 1,
    SS: 2,
    SC: 3,
    SAE: 4,
    USEOVERLAY: 5,
    // ADVANCED    
    UNIVERSAL: 0,
    LOCALQUALITY: 1,
    REMOTEQUALITY: 2,
    PICKHIGHRES: 3,
    PICKFIRSTPART: 4,
    AUTOSERVERLIST: 5,
    // SYSTEM    
    LOGIN: 0,
    USERNAME: 1,
    EMAIL: 2
};

buttonSetting.enableKeys = function () {
    if (Popup.status > 0) {
        document.getElementById("popupAnchor").focus();
    } else {
        document.getElementById("anchor").focus();
    }
};

buttonSetting.keyDown = function () {
    var keyCode = event.keyCode;
    try {
        if (keyLock.checkKey(keyCode)) {
            Main.debug("[buttonSetting.js] - Key pressed: [" + keyCode + "]");
            switch (keyCode) {
                case tvKey.KEY_RETURN:
                case tvKey.KEY_PANEL_RETURN:
                    Main.debug("[buttonSetting.js] - RETURN");
                    widgetAPI.blockNavigation(event);
                    if (Main.screenlock === 1 && buttonSetting.selectedSetting === buttonSetting.SYSTEM && buttonSetting.selectedSubSetting === buttonSetting.LOGIN) {
                        buttonSetting.cancelLoginRequest();
                    } else if (Main.screenlock === 1 && buttonSetting.set !== 0) {
                        buttonSetting.hidePopup();
                    } else if (buttonSetting.lock !== 99 && Main.screenlock === 0) {// if it's not 99 I am in a sub setting
                        buttonSetting.lock = 99;
                        buttonSetting.selectedSubSetting = 0;
                        buttonSetting.selectedSubSettingTop = 131;
                        $('#settingMiddleBg').animate({ 'left': -360 }, 250, function () {
                            $("#settingMiddleBg").hide();
                            $("#leftName").show();
                            $('#leftAll').animate({ 'left': 0 }, 250, function () {
                                $('#settingCatBg').animate({ 'left': 34 }, 250, function () {
                                    var count = Main.getChildLength("settingMain" + buttonSetting.selectedSetting);
                                    for (var i = 0; i < count; i++) {
                                        if (document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + i))
                                            document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + i).style.color = "grey";

                                        if (buttonSetting.selectedSetting !== buttonSetting.PMS) {
                                            if (document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + i + "Button"))
                                                document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + i + "Button").style.color = "grey";
                                        }
                                    }

                                    if ($("#selectedSettingMain" + buttonSetting.selectedSetting + "").length)
                                        $("#selectedSettingMain" + buttonSetting.selectedSetting + "").animate({ 'top': buttonSetting.selectedSubSettingTop }, 0); // move orange bar to top


                                    if (document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right0"))
                                        document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right0").style.color = "white"; // set first entry white

                                    if (buttonSetting.selectedSetting !== buttonSetting.PMS) {
                                        if (document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right0Button"))
                                            document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right0Button").style.color = "white"; // set first entry white
                                    }
                                });
                            });
                        });
                        document.getElementById("bottomPMS").style.display = "none";
                        document.getElementById("bottomPLA").style.display = "none";
                        document.getElementById("bottomENTER").style.display = "none";
                    } else if (buttonSetting.lock === 99) {
                        Main.savePrefs();
                        loadbar.show();
                        Main.startup = true; //reload categories
                        $('#settingCatBg').stop(true, true).animate({ 'left': -473 }, 300, function () {
                            $('#leftAll').stop(true, true).animate({ 'left': -300 }, 250, function () {
                                Main.loadPage("main", "back");
                            });
                        });
                    }
                    break;

                case tvKey.KEY_ENTER:
                case tvKey.KEY_PANEL_ENTER:
                    Main.debug("[buttonSetting.js] - ENTER");
                    buttonSetting.handleEnter();
                    break;

                case tvKey.KEY_RIGHT:
                    Main.debug("[buttonSetting.js] - RIGHT");
                    break;

                case tvKey.KEY_LEFT:
                    Main.debug("[buttonSetting.js] - LEFT");
                    break;

                case tvKey.KEY_UP:
                    Main.debug("[buttonSetting.js] - UP");
                    if (Main.screenlock === 0) {
                        if (buttonSetting.lock === 99 && Main.lock === 0)
                            buttonSetting.selectPrevSetting();
                        else if (buttonSetting.lock === buttonSetting.PMS) {
                            if (buttonSetting.countPMS > 1) {
                                if (Main.lock === 0) {
                                    Main.lock = 1;
                                    buttonSetting.selectPrevPMS();
                                }
                            }
                        } else if (buttonSetting.lock !== buttonSetting.PMS && buttonSetting.lock !== 99 && buttonSetting.lock !== buttonSetting.ABOUT) {
                            if (Main.lock === 0) {
                                Main.lock = 1;
                                buttonSetting.selectPrevSubSetting();
                            }
                        }
                    }
                    break;

                case tvKey.KEY_DOWN:
                    Main.debug("[buttonSetting.js] - DOWN");
                    if (Main.screenlock === 0) {
                        if (buttonSetting.lock === 99 && Main.lock === 0)
                            buttonSetting.selectNextSetting();
                        else if (buttonSetting.lock === buttonSetting.PMS) {
                            if (buttonSetting.countPMS > 1) {
                                if (Main.lock === 0) {
                                    Main.lock = 1;
                                    buttonSetting.selectNextPMS();
                                }
                            }
                        } else if (buttonSetting.lock !== buttonSetting.PMS && buttonSetting.lock !== 99 && buttonSetting.lock !== buttonSetting.ABOUT) {
                            if (Main.lock === 0) {
                                Main.lock = 1;
                                buttonSetting.selectNextSubSetting();
                            }
                        }
                    }
                    break;

                case tvKey.KEY_RED:
                    // ADD PMS + Reset Buffer
                    Main.debug("[buttonSetting.js] - RED");
                    if (Main.screenlock === 0) {
                        if (buttonSetting.lock === buttonSetting.PMS) {
                            Popup.showIPAddress(text.connectToLocalServer, text.enterIPAddress, "", function () {
                                buttonSetting.updatePMS();
                            });
                        } else if (buttonSetting.lock === buttonSetting.PLA)
                            buttonSetting.deleteBuffer();
                    } else if (buttonSetting.lock === buttonSetting.PMS && buttonSetting.set === 0 && Main.serverAdd === 1) {

                    }
                    break;

                case tvKey.KEY_GREEN:
                    // DEFAULT PMS
                    Main.debug("[buttonSetting.js] - GREEN");
                    if (Main.screenlock === 0) {
                        if (buttonSetting.lock === buttonSetting.PMS) {
                            if (!MyPlex.loggedIn) {
                                Popup.showMessage(Popup.INFO, text.preferencesLoginFirst, text.errorNeedMyPlex, text.close);
                            } else {
                                Popup.showMessage(Popup.INFO, text.info, text.preferencesAutoDiscoverPMSProgress, text.close);
                                MyPlex.getServerList(function () {
                                    buttonSetting.updatePMS();
                                    setTimeout(Popup.showMessage, 1000, Popup.INFO, text.info, text.discoveryComplete, text.close);
                                }, true);
                            }
                        }
                    }
                    break;

                case tvKey.KEY_YELLOW:
                    // EDIT PMS
                    Main.debug("[buttonSetting.js] - YELLOW");
                    Main.debug("buttonSetting.lock: " + buttonSetting.lock + " Main.screenlock: " + Main.screenlock + "  buttonSetting.pmsList.length: " + buttonSetting.pmsList.length);
                    if (Main.screenlock === 0) {
                        if (buttonSetting.lock === buttonSetting.PMS && buttonSetting.pmsList.length > 0) {
                            Popup.showIPAddress(text.connectToLocalServer, text.enterIPAddress, prefs.servers[buttonSetting.pmsList[buttonSetting.selectedPMS]].ip, function () {
                                buttonSetting.updatePMS();
                            });
                        }
                    } else if (buttonSetting.lock === buttonSetting.PMS && buttonSetting.set === buttonSetting.EDIT) {
                        buttonSetting.hidePopup();
                    }
                    break;

                case tvKey.KEY_BLUE:
                    // DELETE PMS
                    Main.debug("[buttonSetting.js] - BLUE");
                    if (buttonSetting.lock === buttonSetting.PMS && Main.screenlock === 0) {
                        buttonSetting.handleDelete();
                    }
                    break;

                default:
                    Main.debug("[buttonSetting.js] - Sending key to buttonAll.getKeyEventNonPlayer");
                    buttonAll.getKeyEventNonPlayer(keyCode);
                    break;
            }
        } else {
            widgetAPI.blockNavigation(event);
            Main.debug("[buttonAll.js] - key blocked, keyLock.status: " + keyLock.status);
        }
    } catch (e) {

    }
};

buttonSetting.handleEnter = function () {

    Main.debug("[buttonSetting.js] - buttonSetting.selectedSetting: " + buttonSetting.selectedSetting + ", buttonSetting.lock: " + buttonSetting.lock + ",  buttonSetting.set: " + buttonSetting.set);

    if (buttonSetting.selectedSetting === buttonSetting.PMS && buttonSetting.lock === buttonSetting.PMS) {
        //make sure the user can not hammer on the key and overflood the queue
        if (AjaxManager.xhrQueue.length === 0) {
            buttonSetting.updatePMS();
        }
        else {
            Main.debug("[buttonSetting.js] - Ignoring, the previous refresh is still running");
        }
    }
    else if (buttonSetting.selectedSetting === buttonSetting.GS && buttonSetting.lock === buttonSetting.GS) {
        if (buttonSetting.set === 0) {
            if (buttonSetting.selectedSubSetting === buttonSetting.DB) {
                buttonSetting.setDebug();
            }
            else if (buttonSetting.selectedSubSetting === buttonSetting.FX) {
                buttonSetting.setFX();
            }
            else if (buttonSetting.selectedSubSetting === buttonSetting.TIME) {
                buttonSetting.setTime();
            }
            else if (buttonSetting.selectedSubSetting === buttonSetting.CLOCK) {
                Popup.showSpinner(text.preferencesGSClock, text.preferencesGSPopupClock, text.enter, -12, 12, (prefs.general.clockoffset || "0"), function (value) {
                    prefs.general.clockoffset = value;
                    buttonSetting.updateGS();
                });
            }
            else if (buttonSetting.selectedSubSetting === buttonSetting.TIMEOUT) {
                Popup.showSpinner(text.preferencesGSTimeOut, text.preferencesGSPopupTimeOut, text.enter, 5, 60, (prefs.general.timeout || "10"), function (value) {
                    prefs.general.timeout = value;
                    buttonSetting.updateGS();
                });
            }
            else if (buttonSetting.selectedSubSetting === buttonSetting.SCREENSAVER) {
                Popup.showSpinner(text.preferencesGSScreenSaver, text.preferencesGSPopupScreenSaver, text.enter, 1, 15, (prefs.general.screensaver || "5"), function (value) {
                    prefs.general.screensaver = value;
                    buttonSetting.updateGS();
                });
            }
            else if (buttonSetting.selectedSubSetting === buttonSetting.LANG) {
                buttonSetting.selectNextLanguage();
            }
        }
    }
    else if (buttonSetting.selectedSetting === buttonSetting.PLA && buttonSetting.lock === buttonSetting.PLA) {
        if (buttonSetting.set === 0) {
            if (buttonSetting.selectedSubSetting === buttonSetting.THEME) {
                buttonSetting.setTheme();
            }
            else if (buttonSetting.selectedSubSetting === buttonSetting.TC) {
                buttonSetting.setTranscoding();
            }
            else {
                if (buttonSetting.selectedSubSetting === buttonSetting.FF) {
                    Popup.showNumberInput(text.preferencesPLAFF, text.preferencesPLAPopupFF, text.enter, 1, 3600, (prefs.player.fastforward || "60"), function (value) {
                        if (!isEmpty(value)) {
                            prefs.player.fastforward = value;
                            buttonSetting.updatePLA();
                        }
                    });
                }
                else if (buttonSetting.selectedSubSetting === buttonSetting.RW) {
                    Popup.showNumberInput(text.preferencesPLARW, text.preferencesPLAPopupRW, text.enter, 1, 3600, (prefs.player.rewind || "60"), function (value) {
                        if (!isEmpty(value)) {
                            prefs.player.rewind = value;
                            buttonSetting.updatePLA();
                        }
                    });
                }
                else if (buttonSetting.selectedSubSetting === buttonSetting.IB) {
                    Popup.showNumberInput(text.preferencesPLAInitBuffer, text.preferencesPLAPopupInitBuffer, text.enter, 0, 100, (prefs.player.initBuffer || "0"), function (value) {
                        if (!isEmpty(value)) {
                            prefs.player.initBuffer = value;
                            buttonSetting.updatePLA();
                        }
                    });
                }
                else if (buttonSetting.selectedSubSetting === buttonSetting.PB) {
                    Popup.showNumberInput(text.preferencesPLAPendingBuffer, text.preferencesPLAPopupPendingBuffer, text.enter, 0, 100, (prefs.player.pendingBuffer || "0"), function (value) {
                        if (!isEmpty(value)) {
                            prefs.player.pendingBuffer = value;
                            buttonSetting.updatePLA();
                        }
                    });
                }
                else if (buttonSetting.selectedSubSetting === buttonSetting.TB) {
                    Popup.showNumberInput(text.preferencesPLATotalBuffer, text.preferencesPLAPopupTotalBuffer, text.enter, 0, 100, (prefs.player.totalBuffer || "0"), function (value) {
                        if (!isEmpty(value)) {
                            prefs.player.totalBuffer = value;
                            buttonSetting.updatePLA();
                        }
                    });
                }
            }
        }
    }
    else if (buttonSetting.selectedSetting === buttonSetting.SUBS && buttonSetting.lock === buttonSetting.SUBS) {
        if (buttonSetting.set === 0) {
            if (buttonSetting.selectedSubSetting === buttonSetting.AUDIO) {
                buttonSetting.setAudio();
            } else if (buttonSetting.selectedSubSetting === buttonSetting.BOOST) {
                var boost = Number(prefs.audio.audioboost || "100");
                Popup.showNumberInput(text.preferencesAudioBoost, text.preferencesSUBSPopupAudioBoost, text.enter, 100, 300, boost, function (value) {
                    prefs.audio.audioboost = value;
                    buttonSetting.updateSUBS();
                    Main.debug("[buttonSetting.js] - Setting Audio boost to: [" + prefs.audio.audioboost + "]");
                });
            } else if (buttonSetting.selectedSubSetting === buttonSetting.SAE) {
                buttonSetting.setAlwaysEnabled();
            } else if (buttonSetting.selectedSubSetting === buttonSetting.USEOVERLAY) {
                buttonSetting.setPreferOverlayed();
            } else if (buttonSetting.selectedSubSetting === buttonSetting.SS) {

                var subsize = (prefs.subtitles.size || "22").toString();
                if (subsize.contains("px")) {
                    subsize = subsize.replace("px", "");
                }

                Popup.showSpinner(text.preferencesSubSize, text.preferencesSUBSPopupSubSize, text.enter, 16, 50, subsize, function (value) {
                    prefs.subtitles.size = value;
                    buttonSetting.updateSUBS();

                    // check the position
                    var offsetPos = (value - 15) * 2.79;
                    var newPos = 452 - offsetPos;
                    $("#srtSubtitle").css("top", newPos); // write value to CSS
                    prefs.subtitles.position = (newPos || "0") + "px";
                    $("#srtSubtitle").css("height", (540 - newPos));
                    Main.debug("[buttonSetting.js] - Setting Subtitle Size, adjusted Position to: [" + newPos + "]");
                });
            } else if (buttonSetting.selectedSubSetting === buttonSetting.SC) {
                var subcolor = (prefs.subtitles.color || "22").toString();
                Main.debug("[buttonSetting.js] - subtile color: " + subcolor);
                Popup.showColorPicker(text.preferencesSubColor, text.preferencesSUBSPopupSubColor, subcolor, function (value) {
                    prefs.subtitles.color = value;
                    buttonSetting.updateSUBS();
                });
            }
        }
    } else if (buttonSetting.selectedSetting === buttonSetting.ADVANCED && buttonSetting.lock === buttonSetting.ADVANCED) {

        if (buttonSetting.set === 0) {
            if (buttonSetting.selectedSubSetting === buttonSetting.UNIVERSAL) {
                buttonSetting.setUniversalTranscoder();
            } else if (buttonSetting.selectedSubSetting === buttonSetting.LOCALQUALITY) {
                Popup.showSpinner(text.preferencesLOCALQUALITY, text.preferencesPopupLocalQuality, text.enter, 1, 12, (prefs.player.localQuality || "7"), function (value) {
                    prefs.player.localQuality = value;
                    buttonSetting.updateADV();
                });
            } else if (buttonSetting.selectedSubSetting === buttonSetting.REMOTEQUALITY) {
                Popup.showSpinner(text.preferencesREMOTEQUALITY, text.preferencesPopupRemoteQuality, text.enter, 1, 12, (prefs.player.remoteQuality || "7"), function (value) {
                    prefs.player.remoteQuality = value;
                    buttonSetting.updateADV();
                });
            } else if (buttonSetting.selectedSubSetting === buttonSetting.PICKHIGHRES) {
                buttonSetting.setPickHighRes();
            } else if (buttonSetting.selectedSubSetting === buttonSetting.PICKFIRSTPART) {
                buttonSetting.setPickFirstPart();
            } else if (buttonSetting.selectedSubSetting === buttonSetting.AUTOSERVERLIST) {
                buttonSetting.setAutoServerlist();
            }
        }
    } else if (buttonSetting.selectedSetting === buttonSetting.SYSTEM && buttonSetting.lock === buttonSetting.SYSTEM) {
        if (buttonSetting.set === 0) {
            if (buttonSetting.selectedSubSetting === buttonSetting.USERNAME) {
                //only used for display
            } else if (buttonSetting.selectedSubSetting === buttonSetting.EMAIL) {
                //only used for display
            } else if (buttonSetting.selectedSubSetting === buttonSetting.LOGIN) {
                Main.debug("[buttonSetting.js] - handleEnter, selectedSubSetting: " + buttonSetting.selectedSubSetting + " lock: " + buttonSetting.lock);
                buttonSetting.setLogin();
            }
        }
    } else if (Main.screenlock === 0) {
        buttonSetting.lock = buttonSetting.selectedSetting;
        setTimeout(function () {
            $('#settingCatBg').animate({ 'left': -380 }, 250, function () {
                $("#leftName").hide();
                $("#settingMiddleBg").show();
                $('#leftAll').animate({ 'left': -110 }, 250, function () {
                    $('#settingMiddleBg').animate({ 'left': 180 }, 250, function () {
                        // change the navigation help bar
                        if (buttonSetting.selectedSetting === buttonSetting.PLA) {
                            $("#bottomPLA").show();
                        } else if (buttonSetting.selectedSetting === buttonSetting.PMS) {
                            $("#bottomPMS").show();
                            buttonSetting.updateReachable();
                        } else if (buttonSetting.selectedSetting === buttonSetting.SUBS || buttonSetting.selectedSetting === buttonSetting.GS) {
                            $("#bottomENTER").show();
                        } else if (buttonSetting.selectedSubSetting === buttonSetting.LOGIN || buttonSetting.selectedSubSetting === buttonSetting.REMOTEQUALITY) {
                            $("#bottomENTER").show();
                        }
                    });
                });
            });
        }, 0);
    }
    return false;
};

buttonSetting.selectNextSetting = function () {
    Main.lock = 1;
    document.getElementById("set" + buttonSetting.selectedSetting).style.color = "grey";
    document.getElementById("settingMain" + buttonSetting.selectedSetting).style.display = "none";
    buttonSetting.selectedSetting += 1;
    if (buttonSetting.selectedSetting >= Main.getChildLength("settingSide")) {
        buttonSetting.selectedSetting = 0;
        buttonSetting.selectedSettingTop = 212;
    } else {
        buttonSetting.selectedSettingTop = buttonSetting.selectedSettingTop + 39;
    }
    document.getElementById("settingMain" + buttonSetting.selectedSetting).style.display = "block";
    buttonSetting.slideLeft(buttonSetting.selectedSettingTop);
    Main.debug("[buttonSetting.js] - Preferences selected setting: [" + buttonSetting.selectedSetting + "]");
};

buttonSetting.selectPrevSetting = function () {
    Main.lock = 1;
    document.getElementById("set" + buttonSetting.selectedSetting).style.color = "grey";
    document.getElementById("settingMain" + buttonSetting.selectedSetting).style.display = "none";
    buttonSetting.selectedSetting -= 1;
    if (buttonSetting.selectedSetting < 0) {
        buttonSetting.selectedSetting = Main.getChildLength("settingSide") - 1;
        buttonSetting.selectedSettingTop = 212 + ((Main.getChildLength("settingSide") - 1) * 39);
    } else {
        buttonSetting.selectedSettingTop = buttonSetting.selectedSettingTop - 39;
    }
    document.getElementById("settingMain" + buttonSetting.selectedSetting).style.display = "block";
    buttonSetting.slideLeft(buttonSetting.selectedSettingTop);
    Main.debug("[buttonSetting.js] - Preferences selected setting: [" + buttonSetting.selectedSetting + "]");
};

buttonSetting.slideLeft = function (where) {
    $('#selectedLeft').animate({
        'top': where
    }, 200, function () {
        document.getElementById("set" + buttonSetting.selectedSetting).style.color = "white";
        Main.lock = 0;
    });
};

buttonSetting.slideSetting = function (where, index) {
    $('#selectedSettingMain' + buttonSetting.selectedSetting + '').animate({
        'top': where
    }, 200, function () {
        document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + index).style.color = "white";
        if (buttonSetting.selectedSetting !== buttonSetting.PMS) {
            if (document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + index + "Button"))
                document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + index + "Button").style.color = "white";
        }

        Main.lock = 0;
    });
};

/*
 ###############################
 #
 #       PMS
 #
 ###############################
 */
buttonSetting.selectNextPMS = function () {
    document.getElementById("settingMain2Right" + buttonSetting.selectedPMS).style.color = "grey";

    buttonSetting.selectedPMS += 1;
    buttonSetting.selectedPMSTop += 42;
    if (buttonSetting.selectedPMS >= buttonSetting.countPMS) {
        buttonSetting.selectedPMS = 0;
        buttonSetting.selectedPMSTop = 131;
    }
    buttonSetting.slideSetting(buttonSetting.selectedPMSTop, buttonSetting.selectedPMS);
    Main.debug("[buttonSetting.js] - Preferences selected PMS: [" + prefs.servers[buttonSetting.pmsList[buttonSetting.selectedPMS]].name + "]");
};

buttonSetting.selectPrevPMS = function () {
    document.getElementById("settingMain2Right" + buttonSetting.selectedPMS).style.color = "grey";

    buttonSetting.selectedPMS -= 1;
    buttonSetting.selectedPMSTop -= 42;
    if (buttonSetting.selectedPMS < 0) {
        buttonSetting.selectedPMS = buttonSetting.countPMS - 1;
        buttonSetting.selectedPMSTop = 131 + ((buttonSetting.countPMS - 1) * 42);
    }
    buttonSetting.slideSetting(buttonSetting.selectedPMSTop, buttonSetting.selectedPMS);
    Main.debug("[buttonSetting.js] - Preferences selected PMS: [" + prefs.servers[buttonSetting.pmsList[buttonSetting.selectedPMS]].name + "]");
};

buttonSetting.handleDelete = function () {
    buttonSetting.set = buttonSetting.DELETE;
    prefs.servers.splice(buttonSetting.pmsList[buttonSetting.selectedPMS], 1);
    buttonSetting.pmsList.splice(buttonSetting.selectedPMS, 1);

    for (var i = 0; i < 7; i++) {
        document.getElementById("settingMain2Right" + i).style.color = "grey";
    }

    if (buttonSetting.selectedPMS > 0) {
        buttonSetting.selectedPMS--;
    }

    buttonSetting.selectedPMSTop = 131 + (buttonSetting.selectedPMS * 42);
    buttonSetting.slideSetting(buttonSetting.selectedPMSTop, buttonSetting.selectedPMS);
    buttonSetting.set = 0;

    buttonSetting.updatePMS();
};

buttonSetting.updatePMS = function () {
    buttonSetting.countPMS = 0;
    buttonSetting.pmsList = [];
    var i;
    var url;
    var server;

    for (i = 0; i < 7; i++) { //try all 7 possible servers
        if (prefs.servers[i]) {
            server = new Server(prefs.servers[i].machineIdentifier);
            if (server.owned && !server.synced) {
                buttonSetting.countPMS++;
                buttonSetting.pmsList.push(i);
                prefs.servers[i].reachable = "no"; //reset indication
                url = server.getUrl(0).join("/");
                url = server.appendToken(url);
                setTimeout(Categorie.checkServer, 0, url, i, buttonSetting.updateReachable);
            }
        }
    }

    if (MyPlex.loggedIn) {
        //then try the remote ones
        for (i = 0; i < 7; i++) {
            if (prefs.servers[i]) {
                server = new Server(prefs.servers[i].machineIdentifier);
                if (server.owned && !server.synced) {
                    if (!server.reachable) {
                        url = server.getRemoteAddress() + "/";
                        url = server.appendToken(url);
                        setTimeout(Categorie.checkServer, 5000, url, i, buttonSetting.updateReachable);
                    }
                }
            }
        }
    }


    Main.debug("[buttonSetting.js] - Server count: [" + buttonSetting.countPMS + "]");
    widgetAPI.putInnerHTML(document.getElementById("set2"), text.preferencesSetPMS + " (" + buttonSetting.countPMS + ")");

    buttonSetting.hidePopup();
    buttonSetting.refreshList();
};

buttonSetting.updateReachable = function (id, found) {
    Main.debug("[buttonSetting.js] - buttonSetting.updateReachable id: " + id);
    buttonSetting.refreshList();
};

buttonSetting.refreshList = function () {
    Main.debug("[buttonSetting.js] - buttonSetting.refreshList PMSlist lenght: " + buttonSetting.pmsList.length);

    for (var j = 0; j < 7; j++) {
        widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + j), "");
        widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + j + "Image"), "<img src='Images/blank.png' />");
    }

    for (var i = 0; i < buttonSetting.pmsList.length; i++) {
        var reachable = ((prefs.servers[buttonSetting.pmsList[i]].reachable || "no") == "yes");
        var local = isPrivate(prefs.servers[buttonSetting.pmsList[i]].ip);
        var s;
        if (local && reachable) {
            s = prefs.servers[buttonSetting.pmsList[i]].ip + " - " + prefs.servers[buttonSetting.pmsList[i]].name;
            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + i), s);
            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + i + "Image"), "<img src='Images/setting/online.png' />");
        } else if (!local && reachable) {
            s = prefs.servers[buttonSetting.pmsList[i]].ip + " : " + prefs.servers[buttonSetting.pmsList[i]].port + " - " + prefs.servers[buttonSetting.pmsList[i]].name;
            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + i), s);
            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + i + "Image"), "<img src='Images/setting/remote.png' />");
        } else if (local && !reachable) {
            s = prefs.servers[buttonSetting.pmsList[i]].ip + " - " + prefs.servers[buttonSetting.pmsList[i]].name;
            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + i), s);
            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + i + "Image"), "<img src='Images/setting/offline.png' />");
        } else if (!local && !reachable) {
            s = prefs.servers[buttonSetting.pmsList[i]].ip + " : " + prefs.servers[buttonSetting.pmsList[i]].port + " - " + prefs.servers[buttonSetting.pmsList[i]].name;
            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + i), s);
            widgetAPI.putInnerHTML(document.getElementById("settingMain2Right" + i + "Image"), "<img src='Images/setting/offline.png' />");
        }
    }
};

/*
 ###############################
 #
 #       SUBSETTING NAVI
 #
 ###############################
 */

buttonSetting.selectNextSubSetting = function () {
    document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + buttonSetting.selectedSubSetting).style.color = "grey";
    document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + buttonSetting.selectedSubSetting + "Button").style.color = "grey";

    buttonSetting.selectedSubSetting += 1;
    buttonSetting.selectedSubSettingTop += 42;
    if (buttonSetting.selectedSubSetting >= Main.getChildLength("settingMain" + buttonSetting.selectedSetting)) {
        buttonSetting.selectedSubSetting = 0;
        buttonSetting.selectedSubSettingTop = 131;
    }
    buttonSetting.slideSetting(buttonSetting.selectedSubSettingTop, buttonSetting.selectedSubSetting);
    Main.debug("[buttonSetting.js] - Preferences selected subSetting: [" + buttonSetting.selectedSubSetting + "]");
};

buttonSetting.selectPrevSubSetting = function () {
    document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + buttonSetting.selectedSubSetting).style.color = "grey";
    document.getElementById("settingMain" + buttonSetting.selectedSetting + "Right" + buttonSetting.selectedSubSetting + "Button").style.color = "grey";

    buttonSetting.selectedSubSetting -= 1;
    buttonSetting.selectedSubSettingTop -= 42;
    if (buttonSetting.selectedSubSetting < 0) {
        buttonSetting.selectedSubSetting = Main.getChildLength("settingMain" + buttonSetting.selectedSetting) - 1;
        buttonSetting.selectedSubSettingTop = 131 + ((Main.getChildLength("settingMain" + buttonSetting.selectedSetting) - 1) * 42);
    }
    buttonSetting.slideSetting(buttonSetting.selectedSubSettingTop, buttonSetting.selectedSubSetting);
    Main.debug("[buttonSetting.js] - Preferences selected subSetting: [" + buttonSetting.selectedSubSetting + "]");
};

/*
 ###############################
 #
 #       GENERAL SETTINGS
 #
 ###############################
 */

buttonSetting.updateGS = function () {
    buttonSetting.hidePopup();

    if (Main.debugging === Main.ON)
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.DB + "Button"), "<img src='Images/setting/on.png' />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.DB + "Button"), "<img src='Images/setting/off.png' />");

    if (Main.getTimeType() === "24")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.TIME + "Button"), "<img src='Images/setting/on.png' />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.TIME + "Button"), "<img src='Images/setting/off.png' />");

    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.CLOCK + "Button"), (prefs.general.clockoffset || "0"));


    if ((prefs.general.animations || "on") === "on")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.FX + "Button"), "<img src='Images/setting/on.png' />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.FX + "Button"), "<img src='Images/setting/off.png' />");

    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.TIMEOUT + "Button"), (prefs.general.timeout || "10"));

    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.SCREENSAVER + "Button"), (prefs.general.screensaver || "5"));

    if (Main.language === "en")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.LANG + "Button"), "English");
    else if (Main.language === "nl")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.LANG + "Button"), "Nederlands");
    else if (Main.language === "de")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.LANG + "Button"), "Deutsch");
};

buttonSetting.setDebug = function () {
    Main.setDebugging();

    if (Main.debugging === Main.OFF)
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.DB + "Button"), "<img src='Images/setting/off.png'  />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.DB + "Button"), "<img src='Images/setting/on.png'  />");

    Main.debug("[buttonSetting.js] - Debugging is now: [" + Main.debugging + "]");
};

buttonSetting.setFX = function () {
    if ((prefs.general.animations || "off") === "on") //toggle
    {
        prefs.general.animations = "off";
        $.fx.off = true;
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.FX + "Button"), "<img src='Images/setting/off.png'  />");
    } else {
        prefs.general.animations = "on";
        $.fx.off = false;
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.FX + "Button"), "<img src='Images/setting/on.png'  />");
    }

    Main.debug("[buttonSetting.js] - Animations are now: [" + prefs.general.animations + "]");
};

buttonSetting.setTime = function () {
    Main.setTime();

    if (Main.getTimeType() === "12")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.TIME + "Button"), "<img src='Images/setting/off.png'  />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.TIME + "Button"), "<img src='Images/setting/on.png'  />");

    Main.debug("[buttonSetting.js] - Time is set to: [" + Main.getTimeType() + "h] format");
};

buttonSetting.setLanguage = function () {
    Main.setLanguage();

    if (Main.language === "en")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.LANG + "Button"), "English");
    else if (Main.language === "nl")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.LANG + "Button"), "Nederlands");
    else if (Main.language === "de")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.GS + "Right" + buttonSetting.LANG + "Button"), "Deutsch");
};

buttonSetting.selectNextLanguage = function () {
    var curlang = buttonSetting.languageArray.indexOf(Main.language);

    Main.debug("[buttonSetting.js] - Selected language: [" + curlang + "]");

    if (curlang + 1 > buttonSetting.languageArray.length - 1)
        Main.language = buttonSetting.languageArray[0];
    else
        Main.language = buttonSetting.languageArray[curlang + 1];

    buttonSetting.setLanguage();

    Main.insertTextAll();
    Main.insertTextPreferences();
    buttonSetting.updateABOUT();
};

/*
 ###############################
 #
 #       PLAYER
 #
 ###############################
 */

buttonSetting.updatePLA = function () {

    buttonSetting.hidePopup();

    if (Main.getTheme() === "on")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.THEME + "Button"), "<img src='Images/setting/on.png' />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.THEME + "Button"), "<img src='Images/setting/off.png' />");

    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.FF + "Button"), (prefs.player.fastforward || "60") + " sec");
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.RW + "Button"), (prefs.player.rewind || "60") + " sec");
    var ibuffer = ((prefs.player.initBuffer || "0") === "0") ? text.auto : (prefs.player.initBuffer || "0") + " Mb";
    var pbuffer = ((prefs.player.pendingBuffer || "0") === "0") ? text.auto : (prefs.player.pendingBuffer || "0") + " Mb";
    var tbuffer = ((prefs.player.totalBuffer || "0") === "0") ? text.auto : (prefs.player.totalBuffer || "0") + " Mb";
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.IB + "Button"), ibuffer);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.PB + "Button"), pbuffer);
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TB + "Button"), tbuffer);

    if (Main.getPlaybackMode() === 1) {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TC + "Button"), text.auto);
    } else if (Main.getPlaybackMode() === 2) {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TC + "Button"), text.preferencesDIRECTPLAY);
    } else if (Main.getPlaybackMode() === 3) {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TC + "Button"), text.preferencesDIRECTSTREAM);
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TC + "Button"), text.transcode);
    }
};

buttonSetting.setTheme = function () {
    if (Main.getTheme() === "on") {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.THEME + "Button"), "<img src='Images/setting/off.png'  />");
        prefs.player.playTheme = "off";
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.THEME + "Button"), "<img src='Images/setting/on.png'  />");
        prefs.player.playTheme = "on";
    }
    Main.debug("[buttonSetting.js] - Theme is now: [" + Main.getTheme() + "]");
};

buttonSetting.setTranscoding = function () {
    /*
     1 - Auto
     2 - Direct Play
     3 - Direct Streaming
     4 - Transcoding
     */
    if (Main.getPlaybackMode() === 1) {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TC + "Button"), text.preferencesDIRECTPLAY);
        prefs.player.playbackmode = 2;
    } else if (Main.getPlaybackMode() === 2) {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TC + "Button"), text.preferencesDIRECTSTREAM);
        prefs.player.playbackmode = 3;
    } else if (Main.getPlaybackMode() === 3) {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TC + "Button"), text.transcode);
        prefs.player.playbackmode = 4;
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.PLA + "Right" + buttonSetting.TC + "Button"), text.auto);
        prefs.player.playbackmode = 1;
    }
    Main.debug("[buttonSetting.js] - Playback mode is now: [" + Main.getPlaybackMode() + "]");
};

buttonSetting.deleteBuffer = function () {
    prefs.player.initBuffer = "0";
    prefs.player.pendingBuffer = "0";
    prefs.player.totalBuffer = "0";
    buttonSetting.updatePLA();
};

/*
 ###############################
 #
 #       SOUND / SUBTITLES
 #
 ###############################
 */

buttonSetting.updateSUBS = function () {
    buttonSetting.hidePopup();

    if ((prefs.audio.autoChange || "off") === "on")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.AUDIO + "Button"), "<img src='Images/setting/on.png' />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.AUDIO + "Button"), "<img src='Images/setting/off.png' />");

    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.BOOST + "Button"), (prefs.audio.audioboost || "100") + "%");

    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.SS + "Button"), (prefs.subtitles.size || "22") + "px");
    document.getElementById("colorTexture").style.backgroundColor = (prefs.subtitles.color || "white");

    if ((prefs.subtitles.alwaysEnabled || "off") === "on")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.SAE + "Button"), "<img src='Images/setting/on.png' />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.SAE + "Button"), "<img src='Images/setting/off.png' />");

    if ((prefs.subtitles.preferOverlay || "off") === "on")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.USEOVERLAY + "Button"), "<img src='Images/setting/on.png' />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.USEOVERLAY + "Button"), "<img src='Images/setting/off.png' />");

};

buttonSetting.setAudio = function () {
    if ((prefs.subtitles.autoChange || "off") === "on") {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.AUDIO + "Button"), "<img src='Images/setting/off.png'  />");
        prefs.subtitles.autoChange = "off";
        Main.debug("[buttonSetting.js] - Audio auto change is now: [Off]");
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.AUDIO + "Button"), "<img src='Images/setting/on.png'  />");
        prefs.subtitles.autoChange = "on";
        Main.debug("[buttonSetting.js] - Audio auto change is now: [On]");
    }
};


buttonSetting.setAlwaysEnabled = function () {
    if ((prefs.subtitles.alwaysEnabled || "off") === "on") {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.SAE + "Button"), "<img src='Images/setting/off.png'  />");
        prefs.subtitles.alwaysEnabled = "off";
        Main.debug("[buttonSetting.js] - Subs Always Enabled: [Off]");
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.SAE + "Button"), "<img src='Images/setting/on.png'  />");
        prefs.subtitles.alwaysEnabled = "on";
        Main.debug("[buttonSetting.js] - Subs Always Enabled: [On]");
    }
};

buttonSetting.setPreferOverlayed = function () {
    if ((prefs.subtitles.preferOverlay || "off") === "on") // if file is there its enabled so we have to disable it
    {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.USEOVERLAY + "Button"), "<img src='Images/setting/off.png'  />");
        prefs.subtitles.preferOverlay = "off";
        Main.debug("[buttonSetting.js] - Prefer overlayed subtitles : [Off]");
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SUBS + "Right" + buttonSetting.USEOVERLAY + "Button"), "<img src='Images/setting/on.png'  />");
        prefs.subtitles.preferOverlay = "on";
        Main.debug("[buttonSetting.js] - Prefer overlayed subtitles: [On]");
    }
};

/*
 ###############################
 #
 #       ADVANCED
 #
 ###############################
 */

buttonSetting.updateADV = function () {
    buttonSetting.hidePopup();

    if ((prefs.player.universalTranscoder || "off") === "on")
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.UNIVERSAL + "Button"), "<img src='Images/setting/on.png' />");
    else
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.UNIVERSAL + "Button"), "<img src='Images/setting/off.png' />");

    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.LOCALQUALITY + "Button"), (prefs.player.localQuality || "12"));

    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.REMOTEQUALITY + "Button"), (prefs.player.remoteQuality || "7"));

    if ((prefs.player.pickHighestResolution || "off") === "on") {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKHIGHRES + "Button"), "<img src='Images/setting/on.png' />");
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKHIGHRES + "Button"), "<img src='Images/setting/off.png' />");
    }

    if ((prefs.player.pickFirstPart || "off") === "on") {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKFIRSTPART + "Button"), "<img src='Images/setting/on.png' />");
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKFIRSTPART + "Button"), "<img src='Images/setting/off.png' />");
    }


    if ((prefs.myplex.autoserverlist || "off") === "on") {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.AUTOSERVERLIST + "Button"), "<img src='Images/setting/on.png' />");
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.AUTOSERVERLIST + "Button"), "<img src='Images/setting/off.png' />");
    }
};

buttonSetting.setUniversalTranscoder = function () {
    if ((prefs.player.universalTranscoder || "off") === "off") {
        prefs.player.universalTranscoder = "on";
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.UNIVERSAL + "Button"), "<img src='Images/setting/on.png'  />");
    } else {
        prefs.player.universalTranscoder = "off";
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.UNIVERSAL + "Button"), "<img src='Images/setting/off.png'  />");
    }
    Main.debug("[buttonSetting.js] - UniversalTranscode is now: [" + ((prefs.player.universalTranscoder || "off") === "on") + "]");
};

buttonSetting.setPickHighRes = function () {
    if ((prefs.player.pickHighestResolution || "off") === "off") {
        prefs.player.pickHighestResolution = "on";
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKHIGHRES + "Button"), "<img src='Images/setting/on.png' />");
    } else {
        prefs.player.pickHighestResolution = "off";
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKHIGHRES + "Button"), "<img src='Images/setting/off.png' />");
    }
    Main.debug("[buttonSetting.js] - Always Use Highest Resolution is now: [" + ((prefs.player.pickHighestResolution || "off") === "on") + "]");
};

buttonSetting.setPickFirstPart = function () {
    if ((prefs.player.pickFirstPart || "off") === "off") {
        prefs.player.pickFirstPart = "on";
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKFIRSTPART + "Button"), "<img src='Images/setting/on.png' />");
    } else {
        prefs.player.pickFirstPart = "off";
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.PICKFIRSTPART + "Button"), "<img src='Images/setting/off.png' />");
    }
    Main.debug("[buttonSetting.js] - Always use First Part is now: [" + ((prefs.player.pickFirstPart || "off") === "on") + "]");
};

buttonSetting.setAutoServerlist = function () {
    if ((prefs.myplex.autoserverlist || "on") === "off") {
        prefs.myplex.autoserverlist = "on";
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.AUTOSERVERLIST + "Button"), "<img src='Images/setting/on.png' />");
    } else {
        prefs.myplex.autoserverlist = "off";
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.ADVANCED + "Right" + buttonSetting.AUTOSERVERLIST + "Button"), "<img src='Images/setting/off.png' />");
    }
    Main.debug("[buttonSetting.js] - Auto serverlist is now: [" + ((prefs.myplex.autoserverlist || "off") === "on") + "]");
};

/*
 ###############################
 #
 #      SYSTEM
 #
 ###############################
 */

buttonSetting.updateSYSTEM = function () {
    buttonSetting.hidePopup();
    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.USERNAME + "Button"), prefs.myplex.username || "");

    widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.EMAIL + "Button"), prefs.myplex.userEmail || "");

    if ((prefs.myplex.autoLogin || "off") === "on") {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.LOGIN + "Button"), "<img src='Images/setting/on.png' />");
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.LOGIN), text.preferencesLOGOUT);
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.LOGIN + "Button"), "<img src='Images/setting/off.png' />");
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.LOGIN), text.preferencesLOGIN);
    }

    if (MyPlex.loggedIn && MyPlex.plexPass == "1") {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right3"), text.subscription);
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right3Image"), "<img src='Images/setting/plexpass.png' />");
    } else {
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right3"), text.subscription);
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right3Image"), "<img src='Images/setting/none.png' />");
    }
};

buttonSetting.hideLoginPopup = function () {
    window.clearInterval(buttonSetting.pollTimer); //cancel further polling
    buttonSetting.set = 0;
    Main.screenlock = 0;
};

buttonSetting.setLogin = function () {
    if ((prefs.myplex.autoLogin || "off") === "on") {
        MyPlex.logout();
        Main.handleLogin("FALSE");
        buttonSetting.updateSYSTEM();
        buttonSetting.set = 0;
        Main.screenlock = 0;
    } else {
        buttonSetting.set = buttonSetting.LOGIN;
        loadbar.show();
        MyPlex.loginPIN(buttonSetting.handleLoginRequest);
    }
};

buttonSetting.handleLoginRequest = function (result) {
    if (result === "TRUE") { // we have a pin show the user what to do
        buttonSetting.set = buttonSetting.LOGIN;
        Main.screenlock = 1;

        //start polling
        buttonSetting.pollCounter = 0;
        window.clearInterval(buttonSetting.pollTimer);
        buttonSetting.pollTimer = window.setInterval(buttonSetting.pollLoginRequest, 6000);

        //show message
        Popup.showMessage(Popup.INFO, text.wizardButtonConnect, text.preferencesSYSTEMPopupPinLogin + '<br><span style="color: #FD9800;font-size: 38px;padding: 15px;">' + MyPlex.pinCode + "</span>", text.cancel, function (result) {
            buttonSetting.cancelLoginRequest();
        });

    } else {
        Main.showInfo(text.preferencesLoginFailed, "Login results", text.continue1);
        MyPlex.logout();
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.LOGIN + "Button"), "<img src='Images/setting/off.png' />");
        widgetAPI.putInnerHTML(document.getElementById("settingMain" + buttonSetting.SYSTEM + "Right" + buttonSetting.LOGIN), text.preferencesLOGIN);
        Main.handleLogin("FALSE");
    }
    buttonSetting.set = 0;
};

buttonSetting.pollLoginRequest = function () {
    loadbar.show();
    MyPlex.pollPIN(buttonSetting.handlePollRequest);
};

buttonSetting.handlePollRequest = function (result) {
    loadbar.hide();
    if (result === "TRUE") // we have a token, show that we are signed in
    {
        buttonSetting.pollCounter = 0;
        window.clearInterval(buttonSetting.pollTimer);

        MyPlex.loginWithToken(function () {
            var autoupdate = ((prefs.myplex.autoserverlist || "off") === "on");
            MyPlex.getServerList(function () {
                buttonSetting.updatePMS();
                Popup.showMessage(Popup.INFO, text.wizardButtonConnect, text.preferencesSYSTEMPopupPinSuccess, text.close, function (result) {
                    buttonSetting.cancelLoginRequest();
                });
            }, autoupdate);
        });
    } else {
        if (buttonSetting.pollCounter > 30) //we will try buttonSetting 30 times =  6 sec * 30 = 3 mins
        {
            MyPlex.logout();
            Main.showInfo(text.preferencesLoginTimeOut, "Login results", text.continue1);
        } else {
            buttonSetting.pollCounter++;
            Main.debug("[buttonSetting.js] - pollCounter: " + buttonSetting.pollCounter + " requesting: " + MyPlex.pinUrl);
        }
    }
};

buttonSetting.cancelLoginRequest = function () {
    if ((prefs.myplex.authToken || "") === "") {
        MyPlex.logout();
        Main.handleLogin("FALSE");
    } else {
        prefs.myplex.autoLogin = "on";
        Main.handleLogin("TRUE");
    }
    buttonSetting.set = 0;
    Main.screenlock = 0;
    buttonSetting.updateSYSTEM();
};

/*
 ###############################
 #
 #       ABOUT PLEX
 #
 ###############################
 */

buttonSetting.updateABOUT = function () {
    var resultM = "";
    if (getModel(2010))
        resultM = "C-Series (2010)";
    if (getModel(2011))
        resultM = "D-Series (2011)";
    if (getModel(2012))
        resultM = "E-Series (2012)";
    if (getModel(2013))
        resultM = "F-Series (2013)";
    if (getModel(2014))
        resultM = "G-Series (2014)";

    var resultConT = Network.getConnectionType().toUpperCase();
    if (resultConT === "ERROR")
        resultConT = "undefined";

    var resultIP = Network.GetIP();

    $("#aboutInfoDevice").putInnerHTML(getProductType() + ": " + Main.getModelName());
    $("#aboutInfoModel").putInnerHTML(resultM);
    $("#aboutInfoConType").putInnerHTML(resultConT);
    $("#aboutInfoIP").putInnerHTML(resultIP);
    $("#aboutInfo3D").putInnerHTML(check3DSupport());
    $("#appVersion").putInnerHTML(Application.appVersion);
};

/*
 ###############################
 #
 #       ALL
 #
 ###############################
 */

buttonSetting.hidePopup = function () {
    loadbar.hide();
    buttonSetting.str = "";
    buttonSetting.set = 0;
    Main.screenlock = 0;
};